## ettercap 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ettercap C)

set(VERSION "0.8.0")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

option(ENABLE_CURSES "Enable curses interface" ON)
option(ENABLE_GTK "Enable GTK interface" ON)
option(ENABLE_SSL "Enable SSL support" ON)
option(ENABLE_PLUGINS "Enable plugins support" ON)
option(ENABLE_IPV6 "Enable IPv6 support" OFF)
option(ENABLE_LUA "Enable LUA support (EXPERIMENTAL)" OFF)
option(ENABLE_PDF_DOCS "Enable PDF document generation" OFF)
option(ENABLE_TESTS "Enable Unit Tests" OFF)
option(LIBRARY_BUILD "Build for libettercap only" OFF)
option(INSTALL_DESKTOP "Install ettercap desktop files" ON)


SET(VALID_BUILD_TYPES Debug Release)

if(NOT CMAKE_BUILD_TYPE)
  # Default to using "Release" as our build type.
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING 
    "Choose the type of build, options are: ${VALID_BUILD_TYPES}." FORCE)
endif()
LIST(FIND VALID_BUILD_TYPES ${CMAKE_BUILD_TYPE} contains_valid)
if(contains_valid EQUAL -1)
  message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: '${CMAKE_BUILD_TYPE}'. Valid options are: ${VALID_BUILD_TYPES}") 
endif()
UNSET(contains_valid)

# Ensure that, when we link to stuff outside of our build path, we include the
# library dir path in our RPATH.
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

include(CMakeDependentOption)

# If SYSTEM_LIBS is set to off, then all SYSTEM_* options will be
# set to off.
option(SYSTEM_LIBS "Search for a system-provided libraries. This is only used for libraries that we happen to also bundle. Disabling this implies that we would only use bundled libraries." ON)

# If BUNDLED_LIBS is set to off, then all BUNDLED_* options will be
# set to off.
option(BUNDLED_LIBS
  "Use bundled libraries if system provided versions are not found (or disabled)" ON)

CMAKE_DEPENDENT_OPTION(SYSTEM_CURL 
  "Search for a system-provided version of Curl" ON
  SYSTEM_LIBS OFF)

CMAKE_DEPENDENT_OPTION(BUNDLED_CURL 
  "Use bundled version of Curl if system-provided version is not found (or disabled)" ON
  BUNDLED_LIBS OFF)

CMAKE_DEPENDENT_OPTION(SYSTEM_LIBNET 
  "Search for a system-provided version of LIBNET" ON
  SYSTEM_LIBS OFF)

CMAKE_DEPENDENT_OPTION(BUNDLED_LIBNET 
  "Use bundled version of LIBNET if system-provided version is not found (or disabled)" ON
  BUNDLED_LIBS OFF)

CMAKE_DEPENDENT_OPTION(SYSTEM_LUAJIT
  "Search for a system-provided version of LUAJIT" ON
  "SYSTEM_LIBS;ENABLE_LUA" OFF)

CMAKE_DEPENDENT_OPTION(BUNDLED_LUAJIT
  "Use bundled version of LUAJIT if system-provided version is not found (or disabled)" ON
  "BUNDLED_LIBS;ENABLE_LUA" OFF)

set(SPECIAL_LIB_DIR "" CACHE PATH "Special (non-traditional) root directory where headers/libraries are installed")

include(CheckVariableInHeaders)
include(EttercapOSTest)

#Check and see if we're running Darwin, specify the CMAKE_LIBARY_PATH to do so
if(OS_DARWIN)
	set(CMAKE_SYSTEM_NAME Darwin)
	set(CMAKE_LIBRARY_PATH ${SPECIAL_LIB_DIR}/lib ${CMAKE_LIBRARY_PATH})
	set(CMAKE_INCLUDE_PATH ${SPECIAL_LIB_DIR}/include ${CMAKE_INCLUDE_PATH})
else(OS_DARWIN)
	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /usr/lib64 /usr/lib32)
endif(OS_DARWIN)

if (LIBRARY_BUILD)
	set(ENABLE_GTK OFF)
	set(ENABLE_CURSES OFF)
	set(JUST_LIBRARY 1)
endif(LIBRARY_BUILD)

include(EttercapHeadersCheck)
include(EttercapLibCheck)
include(EttercapVariableCheck)

set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix")
set(INSTALL_SYSCONFDIR /etc CACHE PATH "System configuration directory")
set(INSTALL_LIBDIR ${INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH "Library installation directory")
set(INSTALL_DATADIR ${INSTALL_PREFIX}/share CACHE PATH "Data installation directory")
set(INSTALL_EXECPREFIX ${INSTALL_PREFIX} CACHE PATH "")
set(INSTALL_BINDIR ${INSTALL_PREFIX}/bin CACHE PATH "Binary files installation directory")
set(POLKIT_DIR ${INSTALL_PREFIX}/share/polkit-1/actions/ CACHE PATH "Binary files installation directory")
set(PKEXEC_INSTALL_WRAPPER org.pkexec.ettercap CACHE PATH "Name of the pkexec action file")
set(DESKTOP_DIR ${INSTALL_PREFIX}/share/applications/ CACHE PATH "Binary files installation directory")
set(ICON_DIR ${INSTALL_PREFIX}/share/pixmaps CACHE PATH "Binary files installation directory")
set(MAN_INSTALLDIR ${INSTALL_PREFIX}/share/man CACHE PATH "Path for manual pages") 

set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb3 -DDEBUG -Wall -Wno-pointer-sign -pg" CACHE STRING "" FORCE)
set(CMAKE_C_FLAGS_RELEASE "-O2 -w" CACHE STRING "" FORCE)

if(OS_DARWIN)
set(CMAKE_EXE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl -pg" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
else(OS_DARWIN)
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export-dynamic" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl,-export-dynamic -pg" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export-dynamic" CACHE STRING "" FORCE)
endif(OS_DARWIN)

if(ENABLE_LUA)
  include(EttercapLuajit)
  set(HAVE_EC_LUA 1)
endif(ENABLE_LUA)

set(EC_INCLUDE_PATH ${CMAKE_CURRENT_BINARY_DIR}/include ${CMAKE_SOURCE_DIR}/include)
include_directories(${EC_INCLUDE_PATH})

add_subdirectory(src)
add_subdirectory(desktop)

if(HAVE_PLUGINS)
    if(OS_MINGW)
        message("Sorry, plugins support on Windows is currently unavailable")
    else(OS_MINGW)
        add_subdirectory(plug-ins)
    endif(OS_MINGW)
endif(HAVE_PLUGINS)
add_subdirectory(utils)
add_subdirectory(share)
add_subdirectory(man)

if(ENABLE_IPV6)
    set(WITH_IPV6 TRUE)
endif(ENABLE_IPV6)

# This line should ALWAYS be after all options are defined
configure_file(include/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/include/config.h)

if(ENABLE_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif(ENABLE_TESTS)

# Add a target that will ensure that the build directory is properly cleaned.
add_custom_target(clean-all
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Scripts/clean-all.cmake
)

# If we notice that this isn't the first time they've run 
if(NOT ("${CMAKE_CACHEFILE_DIR}" STREQUAL ""))
  message("")
  message("HAVING TROUBLE BUILDING ETTERCAP? ")
  message("")
  message("  1. Install any missing dependencies")
  message("  2. run 'make clean-all'")
  message("  3. run 'cmake ${CMAKE_SOURCE_DIR}'")
  message("")
endif(NOT ("${CMAKE_CACHEFILE_DIR}" STREQUAL ""))

=== desktop/CMakeLists.txt ===
if(INSTALL_DESKTOP AND ENABLE_GTK)
  CONFIGURE_FILE(org.pkexec.ettercap.policy.in
    ${PKEXEC_INSTALL_WRAPPER}.policy @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PKEXEC_INSTALL_WRAPPER}.policy DESTINATION ${POLKIT_DIR})
  install(FILES ettercap.svg DESTINATION ${ICON_DIR})
  install(FILES ettercap.desktop DESTINATION ${DESKTOP_DIR})
  install(PROGRAMS ettercap-pkexec DESTINATION ${INSTALL_BINDIR})
endif(INSTALL_DESKTOP AND ENABLE_GTK)

=== man/CMakeLists.txt ===
# Add man page custom target
if(ENABLE_PDF_DOCS)
  find_program(GROFF_EXECUTABLE NAMES groff)
  find_program(PS2PDF_EXECUTABLE NAMES ps2pdf)
  set(PDF_FILES)
endif()

set (MAN_NAMES ettercap.8 etterfilter.8 etterlog.8 etter.conf.5)
set(MAN_FILES)

if (ENABLE_PLUGINS)
        set(MAN_NAMES ${MAN_NAMES} ettercap_plugins.8)
endif(ENABLE_PLUGINS)

if (INSTALL_DESKTOP)
        set(MAN_NAMES ${MAN_NAMES} ettercap-pkexec.8)
endif(INSTALL_DESKTOP)

if (ENABLE_CURSES)
        set(MAN_NAMES ${MAN_NAMES} ettercap_curses.8)
endif(ENABLE_CURSES)

foreach (m IN LISTS MAN_NAMES)
        set(mf ${CMAKE_BINARY_DIR}/man/${m})
        list(APPEND MAN_FILES ${mf})

        if(ENABLE_PDF_DOCS)
          set(ps ${CMAKE_BINARY_DIR}/man/${m}.ps)
          set(pdf ${CMAKE_BINARY_DIR}/man/${m}.pdf)

          add_custom_command(OUTPUT ${mf}.ps
          COMMAND ${GROFF_EXECUTABLE} -mandoc -Tps ${mf} > ${ps}
          WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
          COMMENT "Building manpage ${mf}"
          VERBATIM)

          add_custom_command(OUTPUT ${pdf}
          COMMAND ${PS2PDF_EXECUTABLE} ${ps} ${pdf}
          WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
          DEPENDS ${mf}.ps
          COMMENT "Creating PDF for ${ps}"
          VERBATIM)
          list(APPEND PDF_FILES ${pdf})
        endif()
endforeach()

add_custom_target(man ALL DEPENDS ${MAN_FILES})
if(ENABLE_PDF_DOCS)
  add_custom_target(pdf ALL DEPENDS ${PDF_FILES})
endif()

install(FILES ${CMAKE_BINARY_DIR}/man/ettercap.8 ${CMAKE_BINARY_DIR}/man/etterfilter.8 ${CMAKE_BINARY_DIR}/man/etterlog.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
configure_file("ettercap.8.in" "ettercap.8")
configure_file("etterfilter.8.in" "etterfilter.8")
configure_file("etterlog.8.in" "etterlog.8")
configure_file("etter.conf.5.in" "etter.conf.5")

if (ENABLE_PLUGINS)
        install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_plugins.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
	configure_file("ettercap_plugins.8.in" "ettercap_plugins.8")
endif(ENABLE_PLUGINS)

if (ENABLE_CURSES)
        install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_curses.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
	configure_file("ettercap_curses.8.in" "ettercap_curses.8")
endif(ENABLE_CURSES)

if (INSTALL_DESKTOP)
        install(FILES ${CMAKE_BINARY_DIR}/man/ettercap-pkexec.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
	configure_file("ettercap-pkexec.8.in" "ettercap-pkexec.8")
endif(INSTALL_DESKTOP)

install(FILES ${CMAKE_BINARY_DIR}/man/etter.conf.5 DESTINATION ${MAN_INSTALLDIR}/man5/)

=== plug-ins/CMakeLists.txt ===
add_library(arp_cop MODULE arp_cop/arp_cop.c)
set_target_properties(arp_cop PROPERTIES PREFIX "ec_")

add_library(autoadd MODULE autoadd/autoadd.c)
set_target_properties(autoadd PROPERTIES PREFIX "ec_")

add_library(chk_poison MODULE chk_poison/chk_poison.c)
set_target_properties(chk_poison PROPERTIES PREFIX "ec_")

add_library(dns_spoof MODULE dns_spoof/dns_spoof.c)
target_link_libraries(dns_spoof ${HAVE_RESOLV})
set_target_properties(dns_spoof PROPERTIES PREFIX "ec_")

add_library(mdns_spoof MODULE mdns_spoof/mdns_spoof.c)
target_link_libraries(mdns_spoof ${HAVE_RESOLV})
set_target_properties(mdns_spoof PROPERTIES PREFIX "ec_")

add_library(dos_attack MODULE dos_attack/dos_attack.c)
target_link_libraries(dos_attack ${HAVE_LIBNET})
set_target_properties(dos_attack PROPERTIES PREFIX "ec_")

add_library(dummy MODULE dummy/dummy.c)
set_target_properties(dummy PROPERTIES PREFIX "ec_")

add_library(find_conn MODULE find_conn/find_conn.c)
set_target_properties(find_conn PROPERTIES PREFIX "ec_")

add_library(find_ettercap MODULE find_ettercap/find_ettercap.c)
set_target_properties(find_ettercap PROPERTIES PREFIX "ec_")

add_library(find_ip MODULE find_ip/find_ip.c)
set_target_properties(find_ip PROPERTIES PREFIX "ec_")

add_library(finger MODULE finger/finger.c)
set_target_properties(finger PROPERTIES PREFIX "ec_")

add_library(finger_submit MODULE finger_submit/finger_submit.c)
set_target_properties(finger_submit PROPERTIES PREFIX "ec_")

add_library(fraggle_attack MODULE fraggle_attack/fraggle_attack.c)
set_target_properties(fraggle_attack PROPERTIES PREFIX "ec_")

add_library(gre_relay MODULE gre_relay/gre_relay.c)
set_target_properties(gre_relay PROPERTIES PREFIX "ec_")

add_library(gw_discover MODULE gw_discover/gw_discover.c)
set_target_properties(gw_discover PROPERTIES PREFIX "ec_")

add_library(isolate MODULE isolate/isolate.c)
set_target_properties(isolate PROPERTIES PREFIX "ec_")

add_library(link_type MODULE link_type/link_type.c)
set_target_properties(link_type PROPERTIES PREFIX "ec_")

add_library(nbns_spoof MODULE nbns_spoof/nbns_spoof.c)
set_target_properties(nbns_spoof PROPERTIES PREFIX "ec_")

if(HAVE_PCRE)
    if(CURL_FOUND)
        add_library(sslstrip MODULE sslstrip/sslstrip.c)
        include_directories(${CURL_INCLUDE_DIR} ${PCRE_INCLUDE_DIR})
        add_dependencies(sslstrip curl)
        target_link_libraries(sslstrip ${CURL_LIBRARY} ${PCRE_LIBRARY})
        set_target_properties(sslstrip PROPERTIES PREFIX "ec_")
        set(SSL_STRIP_PLUGIN sslstrip)
    else(CURL_FOUND)
        message(STATUS "Not building sslstrip plugin. Requires libcurl.")
    endif(CURL_FOUND)
else(HAVE_PCRE)
    message(STATUS "Not building sslstrip plugin. Requires pcre.")
endif(HAVE_PCRE)

add_library(pptp_chapms1 MODULE pptp_chapms1/pptp_chapms1.c)
set_target_properties(pptp_chapms1 PROPERTIES PREFIX "ec_")

add_library(pptp_clear MODULE pptp_clear/pptp_clear.c)
set_target_properties(pptp_clear PROPERTIES PREFIX "ec_")

add_library(pptp_pap MODULE pptp_pap/pptp_pap.c)
set_target_properties(pptp_pap PROPERTIES PREFIX "ec_")

add_library(pptp_reneg MODULE pptp_reneg/pptp_reneg.c)
set_target_properties(pptp_reneg PROPERTIES PREFIX "ec_")

add_library(rand_flood MODULE rand_flood/rand_flood.c)
set_target_properties(rand_flood PROPERTIES PREFIX "ec_")

add_library(remote_browser MODULE remote_browser/remote_browser.c)
set_target_properties(remote_browser PROPERTIES PREFIX "ec_")

add_library(reply_arp MODULE reply_arp/reply_arp.c)
set_target_properties(reply_arp PROPERTIES PREFIX "ec_")

add_library(repoison_arp MODULE repoison_arp/repoison_arp.c)
set_target_properties(repoison_arp PROPERTIES PREFIX "ec_")

add_library(scan_poisoner MODULE scan_poisoner/scan_poisoner.c)
set_target_properties(scan_poisoner PROPERTIES PREFIX "ec_")

add_library(search_promisc MODULE search_promisc/search_promisc.c)
set_target_properties(search_promisc PROPERTIES PREFIX "ec_")

add_library(smb_clear MODULE smb_clear/smb_clear.c)
set_target_properties(smb_clear PROPERTIES PREFIX "ec_")

add_library(smb_down MODULE smb_down/smb_down.c)
set_target_properties(smb_down PROPERTIES PREFIX "ec_")

add_library(smurf_attack MODULE smurf_attack/smurf_attack.c)
set_target_properties(smurf_attack PROPERTIES PREFIX "ec_")

add_library(stp_mangler MODULE stp_mangler/stp_mangler.c)
set_target_properties(stp_mangler PROPERTIES PREFIX "ec_")

set(PLUGINS arp_cop
autoadd
chk_poison
dns_spoof
mdns_spoof
dos_attack
dummy
find_conn
find_ettercap
find_ip
finger
finger_submit
fraggle_attack
gre_relay
gw_discover
isolate
link_type
nbns_spoof
${SSL_STRIP_PLUGIN}
pptp_chapms1
pptp_clear
pptp_pap
pptp_reneg
rand_flood
remote_browser
reply_arp
repoison_arp
scan_poisoner
search_promisc
smb_clear
smb_down
smurf_attack
stp_mangler)

foreach(plugin ${PLUGINS})
	target_link_libraries(${plugin} lib_ettercap)
endforeach(plugin)

install(TARGETS
            arp_cop
            autoadd
            chk_poison
            dns_spoof
	    mdns_spoof
            dos_attack
            dummy
            find_conn
            find_ettercap
            find_ip
            finger
            finger_submit
            fraggle_attack
            gre_relay
            gw_discover
            isolate
            link_type
            nbns_spoof
            ${SSL_STRIP_PLUGIN}
            pptp_chapms1
            pptp_clear
            pptp_pap
            pptp_reneg
            rand_flood
            remote_browser
            reply_arp
            repoison_arp
            scan_poisoner
            search_promisc
            smb_clear
            smb_down
            smurf_attack
            stp_mangler
        LIBRARY DESTINATION ${INSTALL_LIBDIR}/ettercap/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                    GROUP_READ GROUP_EXECUTE
                    WORLD_READ WORLD_EXECUTE)

=== share/CMakeLists.txt ===
install(FILES etter.conf etter.dns etter.mdns etter.nbns DESTINATION ${INSTALL_SYSCONFDIR}/ettercap)

if(ENABLE_IPV6)
	install(FILES etter.conf.v6 DESTINATION ${INSTALL_SYSCONFDIR}/ettercap RENAME etter.conf)
else(ENABLE_IPV6)
	install(FILES etter.conf DESTINATION ${INSTALL_SYSCONFDIR}/ettercap)
endif(ENABLE_IPV6)

install(FILES
            ettercap.png
            etter.fields
            etter.filter
            etterfilter.cnt
            etter.filter.examples
            etter.filter.kill
            etter.filter.pcre
            etter.filter.ssh
            etterfilter.tbl
            etter.finger.mac
            etter.finger.os
            etterlog.dtd
            etter.mime
            etter.services
            etter.ssl.crt
        DESTINATION ${INSTALL_DATADIR}/ettercap)

=== src/CMakeLists.txt ===
set(EC_SRC
        ec_capture.c
        ec_checksum.c
        ec_conf.c
        ec_connbuf.c
        ec_conntrack.c
        ec_debug.c
        ec_decode.c
        ec_dispatcher.c
        ec_dissect.c
        ec_encryption_ccmp.c
        ec_encryption_tkip.c
        ec_encryption.c
        ec_error.c
        ec_exit.c
        ec_file.c
        ec_filter.c
        ec_fingerprint.c
        ec_format.c
        ec_globals.c
        ec_hash.c
        ec_hook.c
        ec_inet.c
        ec_inject.c
        ec_log.c
        ec_manuf.c
        ec_mitm.c
        ec_network.c
        ec_packet.c
        ec_parser.c
        ec_passive.c
        ec_plugins.c
        ec_poll.c
        ec_profiles.c
        ec_resolv.c
        ec_scan.c
        ec_send.c
        ec_services.c
        ec_session.c
        ec_signals.c
        ec_sniff_bridge.c
        ec_sniff.c
        ec_sniff_unified.c
        ec_socket.c
        ec_sslwrap.c
        ec_stats.c
        ec_streambuf.c
        ec_strings.c
        ec_threads.c
        ec_ui.c

        dissectors/ec_bgp.c
        dissectors/ec_cvs.c
        dissectors/ec_dhcp.c
        dissectors/ec_ftp.c
        dissectors/ec_http.c
        dissectors/ec_icq.c
        dissectors/ec_imap.c
        dissectors/ec_irc.c
        dissectors/ec_iscsi.c
        dissectors/ec_ldap.c
        dissectors/ec_mdns.c
        dissectors/ec_mongodb.c
        dissectors/ec_mountd.c
        dissectors/ec_msn.c
        dissectors/ec_mysql.c
        dissectors/ec_nbns.c
        dissectors/ec_nntp.c
        dissectors/ec_o5logon.c
        dissectors/ec_ospf.c
        dissectors/ec_pop.c
        dissectors/ec_postgresql.c
        dissectors/ec_portmap.c
        dissectors/ec_radius.c
        dissectors/ec_rcon.c
        dissectors/ec_rip.c
        dissectors/ec_rlogin.c
        dissectors/ec_smb.c
        dissectors/ec_smtp.c
        dissectors/ec_snmp.c
        dissectors/ec_socks.c
        dissectors/ec_telnet.c
        dissectors/ec_TN3270.c
        dissectors/ec_vnc.c
        dissectors/ec_vrrp.c
        dissectors/ec_x11.c
        dissectors/ec_ymsg.c

        mitm/ec_arp_poisoning.c
        mitm/ec_dhcp_spoofing.c
        mitm/ec_icmp_redirect.c
        mitm/ec_port_stealing.c

        protocols/ec_arp.c
        protocols/ec_cooked.c
        protocols/ec_erf.c
        protocols/ec_eth.c
        protocols/ec_fddi.c
        protocols/ec_gre.c
        protocols/ec_icmp.c
        protocols/ec_ip.c
        protocols/ec_mpls.c
        protocols/ec_pap.c
        protocols/ec_ppi.c
        protocols/ec_ppp.c
        protocols/ec_pppoe.c
        protocols/ec_rawip.c
        protocols/ec_tcp.c
        protocols/ec_tr.c
        protocols/ec_udp.c
        protocols/ec_vlan.c
        protocols/ec_wifi.c
        protocols/ec_wifi_eapol.c
        protocols/ec_wifi_prism.c
        protocols/ec_wifi_radiotap.c
)

if (NOT LIBRARY_BUILD)
	set(EC_SRC ${EC_SRC} ec_interfaces.c)
endif(NOT LIBRARY_BUILD)

if(ENABLE_IPV6)
    set(EC_SRC ${EC_SRC} protocols/ec_icmp6.c protocols/ec_ip6.c mitm/ec_ip6nd_poison.c)
endif(ENABLE_IPV6)

if(HAVE_DN_EXPAND)
    set(EC_SRC ${EC_SRC} dissectors/ec_dns.c)
endif(HAVE_DN_EXPAND)

if(ENABLE_SSL)
   set(EC_SRC ${EC_SRC} dissectors/ec_ssh.c)
   set(EC_SRC ${EC_SRC} dissectors/ec_gg.c)
endif(ENABLE_SSL)

if(OS_LINUX)
    set(EC_SRC ${EC_SRC} os/ec_linux.c)
elseif(OS_BSD)
    set(EC_SRC ${EC_SRC} os/ec_bsd.c)
elseif(OS_DARWIN)
    set(EC_SRC ${EC_SRC} os/ec_darwin.c)
elseif(OS_MINGW)
    set(EC_SRC ${EC_SRC} os/ec_mingw.c)
elseif(OS_SOLARIS)
    set(EC_SRC ${EC_SRC} os/ec_solaris.c)
endif()

if(NOT HAVE_STRLCAT)
    set(EC_SRC ${EC_SRC} missing/strlcat.c)
endif(NOT HAVE_STRLCAT)
if(NOT HAVE_STRLCPY)
    set(EC_SRC ${EC_SRC} missing/strlcpy.c)
endif(NOT HAVE_STRLCPY)
if(NOT HAVE_STRSEP)
    set(EC_SRC ${EC_SRC} missing/strsep.c)
endif(NOT HAVE_STRSEP)
if(NOT HAVE_STRCASESTR)
    set(EC_SRC ${EC_SRC} missing/strcasestr.c)
endif(NOT HAVE_STRCASESTR)
if(NOT HAVE_MEMMEM)
    set(EC_SRC ${EC_SRC} missing/memmem.c)
endif(NOT HAVE_MEMMEM)
if(NOT HAVE_BASENAME)
    set(EC_SRC ${EC_SRC} missing/basename.c)
endif(NOT HAVE_BASENAME)
if(NOT HAVE_STRNDUP)
    set(EC_SRC ${EC_SRC} missing/strndup.c)
endif(NOT HAVE_STRNDUP)


if(NOT LIBRARY_BUILD)
	add_subdirectory(interfaces)
endif(NOT LIBRARY_BUILD)

add_library(lib_ettercap SHARED ${EC_SRC})
add_dependencies(lib_ettercap libnet)

if (NOT LIBRARY_BUILD)
	add_executable(ettercap ec_main.c)
endif(NOT LIBRARY_BUILD)

# Only compile lua stuff if lua is enabled!
IF(ENABLE_LUA)
  add_subdirectory(lua)
  target_link_libraries(lib_ettercap ec_lua)
  if(OS_DARWIN AND (CMAKE_SIZEOF_VOID_P EQUAL 8))
    # On 64-bit OSX platforms, luajit requires the following flags to be added.
    # See: http://luajit.org/install.html
    get_target_property(OLD_FLAGS ettercap LINK_FLAGS)
    if(OLD_FLAGS STREQUAL "OLD_FLAGS-NOTFOUND")
      set(OLD_FLAGS "")
    endif()
    set(NEW_FLAGS "${OLD_FLAGS} -pagezero_size 10000 -image_base 100000000")
    SET_TARGET_PROPERTIES(ettercap PROPERTIES LINK_FLAGS "${NEW_FLAGS}")
  endif()
endif(ENABLE_LUA)

if(NOT LIBRARY_BUILD)
	target_link_libraries(lib_ettercap ec_interfaces ${EC_LIBS})
else(NOT LIBRARY_BUILD)
	target_link_libraries(lib_ettercap ${EC_LIBS})
endif(NOT LIBRARY_BUILD)

set_target_properties(lib_ettercap PROPERTIES 
  ENABLE_EXPORTS On
  LINK_INTERFACE_LIBRARIES ""
  #  INSTALL_RPATH ${INSTALL_LIBDIR}
  OUTPUT_NAME ettercap
  )

if (NOT LIBRARY_BUILD)
	target_link_libraries(ettercap lib_ettercap)
	set_target_properties(ettercap PROPERTIES 
  	INSTALL_RPATH ${INSTALL_LIBDIR}
  	)
endif(NOT LIBRARY_BUILD)
install(TARGETS lib_ettercap DESTINATION ${INSTALL_LIBDIR})
if(NOT LIBRARY_BUILD)
	install(TARGETS ettercap DESTINATION ${INSTALL_BINDIR})
endif(NOT LIBRARY_BUILD)

=== tests/CMakeLists.txt ===
add_subdirectory(check)

include_directories(. ../include ${CHECK_INCLUDE_DIR})

add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} -V)

# Adds a test by name
macro(_t NAME)
  add_executable(test_${NAME} test_${NAME}.c)
  add_dependencies(test_${NAME} bundled_check)
  target_link_libraries(test_${NAME} lib_ettercap ${CHECK_LIBRARY})
  add_test(test_${NAME} ${CMAKE_CURRENT_BINARY_DIR}/test_${NAME})
endmacro(_t NAME)

_t(ec_decode)

=== utils/CMakeLists.txt ===
## Etterfilter

set(EF_SRC
            etterfilter/ef_compiler.c
            etterfilter/ef_ec_compat.c
            etterfilter/ef_encode.c
            etterfilter/ef_main.c
            etterfilter/ef_output.c
            etterfilter/ef_parser.c
            etterfilter/ef_tables.c
            etterfilter/ef_test.c
            ${CMAKE_SOURCE_DIR}/src/ec_error.c
            ${CMAKE_SOURCE_DIR}/src/ec_file.c
            ${CMAKE_SOURCE_DIR}/src/ec_filter.c
            ${CMAKE_SOURCE_DIR}/src/ec_strings.c
)

if(NOT HAVE_STRLCPY)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strlcpy.c)
endif(NOT HAVE_STRLCPY)

if(NOT HAVE_STRSEP)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strsep.c)
endif(NOT HAVE_STRSEP)

if(NOT HAVE_MEMMEM)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/memmem.c)
endif(NOT HAVE_MEMMEM)

if(NOT HAVE_INET_ATON)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/inet_aton.c)
endif(NOT HAVE_INET_ATON)

if(NOT HAVE_GETOPT_LONG)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/getopt.c)
endif(NOT HAVE_GETOPT_LONG)

if(NOT HAVE_STRNDUP)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strndup.c)
endif(NOT HAVE_STRNDUP)

find_package(BISON)
find_package(FLEX)
BISON_TARGET(EF_PARSER etterfilter/ef_grammar.y ${CMAKE_CURRENT_BINARY_DIR}/ef_grammar.c)
FLEX_TARGET(EF_SCANNER etterfilter/ef_syntax.l ${CMAKE_CURRENT_BINARY_DIR}/ef_syntax.c)
ADD_FLEX_BISON_DEPENDENCY(EF_SCANNER EF_PARSER)

# For ef_grammar.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(etterfilter ${EF_SRC} ${FLEX_EF_SCANNER_OUTPUTS} ${BISON_EF_PARSER_OUTPUTS})
target_link_libraries(etterfilter ${EF_LIBS})

## Etterlog

set(EL_SRC
            etterlog/el_analyze.c
            etterlog/el_conn.c
            etterlog/el_decode.c
            etterlog/el_decode_http.c
            etterlog/el_display.c
            etterlog/el_ec_compat.c
            etterlog/el_log.c
            etterlog/el_main.c
            etterlog/el_parser.c
            etterlog/el_profiles.c
            etterlog/el_stream.c
            etterlog/el_target.c
            ${CMAKE_SOURCE_DIR}/src/ec_error.c 
            ${CMAKE_SOURCE_DIR}/src/ec_fingerprint.c 
            ${CMAKE_SOURCE_DIR}/src/ec_manuf.c 
            ${CMAKE_SOURCE_DIR}/src/ec_services.c 
            ${CMAKE_SOURCE_DIR}/src/ec_hash.c 
            ${CMAKE_SOURCE_DIR}/src/ec_file.c 
            ${CMAKE_SOURCE_DIR}/src/ec_inet.c 
            ${CMAKE_SOURCE_DIR}/src/ec_passive.c 
            ${CMAKE_SOURCE_DIR}/src/ec_strings.c 
            ${CMAKE_SOURCE_DIR}/src/ec_format.c
)

if(NOT HAVE_BASENAME)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/basename.c)
endif(NOT HAVE_BASENAME)

if(NOT HAVE_STRCASESTR)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strcasestr.c)
endif(NOT HAVE_STRCASESTR)

if(NOT HAVE_STRLCAT)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strlcat.c)
endif(NOT HAVE_STRLCAT)

if(NOT HAVE_STRSEP)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strsep.c)
endif(NOT HAVE_STRSEP)

if(NOT HAVE_MEMMEM)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/memmem.c)
endif(NOT HAVE_MEMMEM)

if(NOT HAVE_INET_ATON)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/inet_aton.c)
endif(NOT HAVE_INET_ATON)

if(NOT HAVE_GETOPT_LONG)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/getopt.c)
endif(NOT HAVE_GETOPT_LONG)

if(NOT HAVE_STRNDUP)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strndup.c)
endif(NOT HAVE_STRNDUP)

add_executable(etterlog ${EL_SRC})
target_link_libraries(etterlog ${EL_LIBS})

install(TARGETS etterfilter etterlog DESTINATION ${INSTALL_BINDIR})

=== bundled_deps/curl/CMakeLists.txt ===
# This file provides the 'bundled_curl' target.

# This will build curl using the release that we've included with
# our distribution of ettercap.
include(ExternalProject)
SET(CURL_VERSION 7.32.0)
SET(CURL_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
SET(CURL_TARGET bundled-curl-${CURL_VERSION}-${CMAKE_BUILD_TYPE})
SET(CURL_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${CURL_TARGET})

SET(CURL_CONFIGURE_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_configure_wrapper.sh)
SET(CURL_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_build_wrapper.sh)
SET(CURL_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/curl_install_wrapper.sh)

SET(CURL_PREFIX ${CURL_BUILD_ROOT}/usr)
SET(CURL_LIB_DIR ${CURL_PREFIX}/lib)
SET(CURL_INCLUDE_DIR ${CURL_PREFIX}/include)

if (NOT OPENSSL_LIBRARIES)
  message(FATAL_ERROR "Cannot build bundled Curl without OpenSSL support enabled (ENABLE_SSL=On)")
endif()

if (NOT ZLIB_LIBRARIES)
  message(FATAL_ERROR "Cannot build bundled Curl without zlib")
endif()

# Ensure that we include all the required stuff for linking to libcurl
SET(CURL_LIBRARY ${CURL_LIB_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}curl${CMAKE_STATIC_LIBRARY_SUFFIX}
  ${OPENSSL_LIBRARIES}
  ${ZLIB_LIBRARIES}
  )  

#Figure out the parent directory for our openssl installation.
get_filename_component(OPENSSL_ROOT_PATH ${OPENSSL_INCLUDE_DIR} PATH)

SET(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
SET(EXPORT_C_FLAGS ${CMAKE_C_FLAGS} -fPIC)

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
ELSEIF("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
ENDIF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")

SET(EXPORT_PREFIX ${CURL_PREFIX})

# Enable/Disable IPV6
SET(EXPORT_IPV6_FLAGS --disable-ipv6)
if(ENABLE_IPV6)
  SET(EXPORT_IPV6_FLAGS --enable-ipv6)
endif()

CONFIGURE_FILE(${CURL_SOURCE_DIR}/curl_configure_wrapper.sh.in 
  ${CURL_CONFIGURE_WRAPPER} @ONLY)
CONFIGURE_FILE(${CURL_SOURCE_DIR}/curl_build_wrapper.sh.in 
  ${CURL_BUILD_WRAPPER} @ONLY)
CONFIGURE_FILE(${CURL_SOURCE_DIR}/curl_install_wrapper.sh.in 
  ${CURL_INSTALL_WRAPPER} @ONLY)

#########################

ExternalProject_Add(
  ${CURL_TARGET}
  URL ${CURL_SOURCE_DIR}/curl-${CURL_VERSION}.tar.gz
  BUILD_IN_SOURCE 1
  SOURCE_DIR ${CURL_BUILD_ROOT}/build
  CONFIGURE_COMMAND sh ${CURL_CONFIGURE_WRAPPER}
  BUILD_COMMAND sh ${CURL_BUILD_WRAPPER}
  INSTALL_COMMAND sh ${CURL_INSTALL_WRAPPER}
  UPDATE_COMMAND ""
  )

# Now export our variables to our parent's scope.
set(CURL_VERSION_STRING ${CURL_VERSION} PARENT_SCOPE)
set(CURL_LIBRARY ${CURL_LIBRARY} PARENT_SCOPE)
set(CURL_INCLUDE_DIR ${CURL_INCLUDE_DIR} PARENT_SCOPE)
set(CURL_FOUND TRUE PARENT_SCOPE)
add_custom_target(bundled_curl)
add_dependencies(bundled_curl ${CURL_TARGET})

=== bundled_deps/libnet/CMakeLists.txt ===
# This file provides the 'bundled_libnet' target.

# This will build libnet using the release that we've included with
# our distribution of ettercap.
include(ExternalProject)
SET(LIBNET_VERSION 1.1.6)
SET(LIBNET_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
SET(LIBNET_TARGET bundled-libnet-${LIBNET_VERSION}-${CMAKE_BUILD_TYPE})
SET(LIBNET_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${LIBNET_TARGET})
SET(LIBNET_CONFIGURE_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_configure_wrapper.sh)
SET(LIBNET_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_build_wrapper.sh)
SET(LIBNET_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/libnet_install_wrapper.sh)

SET(LIBNET_PREFIX ${LIBNET_BUILD_ROOT}/usr)
SET(LIBNET_LIB_DIR ${LIBNET_PREFIX}/lib)
SET(LIBNET_INCLUDE_DIR ${LIBNET_PREFIX}/include)
set(LIBNET_LIBRARY ${LIBNET_LIB_DIR}/${CMAKE_STATIC_LIBRARY_PREFIX}net${CMAKE_STATIC_LIBRARY_SUFFIX})  

# Configure the Makefile wrapper. The purpose of this wrapper is to set up
# the environment for building libnet. ExternalProject_Add doesn't 
# support setting up any sort of environment, nor does it handle arguments to
# BUILD_COMMAND (and others) that contain double-quotes. According to 
# the CMake folks, this is the way to do things.
#  ref: http://www.cmake.org/pipermail/cmake/2010-April/036566.html
# 
SET(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
SET(EXPORT_C_FLAGS ${CMAKE_C_FLAGS} -fPIC)

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
ELSEIF("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
ENDIF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")

SET(EXPORT_PREFIX ${LIBNET_PREFIX})

CONFIGURE_FILE(${LIBNET_SOURCE_DIR}/libnet_configure_wrapper.sh.in 
  ${LIBNET_CONFIGURE_WRAPPER} @ONLY)
CONFIGURE_FILE(${LIBNET_SOURCE_DIR}/libnet_build_wrapper.sh.in 
  ${LIBNET_BUILD_WRAPPER} @ONLY)
CONFIGURE_FILE(${LIBNET_SOURCE_DIR}/libnet_install_wrapper.sh.in 
  ${LIBNET_INSTALL_WRAPPER} @ONLY)

#########################

ExternalProject_Add(
  ${LIBNET_TARGET}
  URL ${LIBNET_SOURCE_DIR}/libnet-${LIBNET_VERSION}.tar.gz
  BUILD_IN_SOURCE 1
  SOURCE_DIR ${LIBNET_BUILD_ROOT}/build
  CONFIGURE_COMMAND sh ${LIBNET_CONFIGURE_WRAPPER}
  BUILD_COMMAND sh ${LIBNET_BUILD_WRAPPER}
  INSTALL_COMMAND sh ${LIBNET_INSTALL_WRAPPER}
  UPDATE_COMMAND ""
  )

# Now export our variables to our parent's scope.
set(LIBNET_VERSION ${LIBNET_VERSION} PARENT_SCOPE)
set(LIBNET_LIBRARY ${LIBNET_LIBRARY} PARENT_SCOPE)
set(LIBNET_INCLUDE_DIR ${LIBNET_INCLUDE_DIR} PARENT_SCOPE)
set(LIBNET_FOUND TRUE PARENT_SCOPE)
add_custom_target(bundled_libnet)
add_dependencies(bundled_libnet ${LIBNET_TARGET})

=== bundled_deps/luajit/CMakeLists.txt ===
include(ExternalProject)
SET(LUAJIT_VERSION 2.0.2)
SET(LUAJIT_TARGET bundled-luajit-${LUAJIT_VERSION}-${CMAKE_BUILD_TYPE})
SET(LUAJIT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
SET(LUAJIT_BUILD_ROOT ${CMAKE_CURRENT_BINARY_DIR}/${LUAJIT_TARGET})
SET(LUAJIT_BUILD_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/luajit_build_wrapper.sh)
SET(LUAJIT_INSTALL_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/luajit_install_wrapper.sh)

SET(LUAJIT_PREFIX ${LUAJIT_BUILD_ROOT}/usr)
SET(LUAJIT_LIB_DIR ${LUAJIT_PREFIX}/lib)
set(LUAJIT_INCLUDE_DIR ${LUAJIT_PREFIX}/include/luajit-2.0)

# LuaJIT requires both libm and libdl.. Let's find those.

find_library(LIB_M m)
if(NOT LIB_M)
  message(FATAL_ERROR "Could not find libm, which is required by luajit.")
endif()

find_library(LIB_DL dl)
if(NOT LIB_DL)
  message(FATAL_ERROR "Could not find libdl, which is required by luajit.")
endif()


set(LUAJIT_LIBRARY 
  ${LUAJIT_PREFIX}/lib/${CMAKE_STATIC_LIBRARY_PREFIX}luajit-5.1${CMAKE_STATIC_LIBRARY_SUFFIX}
  ${LIB_M}
  ${LIB_DL}
  )

# Configure the Makefile wrapper. The purpose of this wrapper is to set up
# the environment for building luajit. ExternalProject_Add doesn't 
# support setting up any sort of environment, nor does it handle arguments to
# BUILD_COMMAND (and others) that contain double-quotes. According to 
# the CMake folks, this is the way to do things.
#  ref: http://www.cmake.org/pipermail/cmake/2010-April/036566.html
# 
SET(EXPORT_CC ${CMAKE_C_COMPILER})

# -fPIC is required so that we can link in our static library, properly.
# Add the cmake env cflags and all that jazz so we can inherit architectures
# and the like.
SET(EXPORT_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

IF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  SET(EXPORT_CCDEBUG "-g")
  # Explicitly disable CCOPT, as we do not want fomit-frame-pointer 
  # conflicting with debuggy stuff.
  SET(EXPORT_DISABLE_CCOPT CCOPT=)
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_DEBUG}")
ELSEIF("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
  SET(EXPORT_CCDEBUG "")
  SET(EXPORT_C_FLAGS "${EXPORT_C_FLAGS} ${CMAKE_C_FLAGS_RELEASE}")
ENDIF("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")

SET(EXPORT_BUILDMODE static)
SET(EXPORT_PREFIX ${LUAJIT_PREFIX})

CONFIGURE_FILE(${LUAJIT_SOURCE_DIR}/luajit_build_wrapper.sh.in 
               ${LUAJIT_BUILD_WRAPPER} @ONLY)
CONFIGURE_FILE(${LUAJIT_SOURCE_DIR}/luajit_install_wrapper.sh.in 
               ${LUAJIT_INSTALL_WRAPPER} @ONLY)

#########################

ExternalProject_Add(
    ${LUAJIT_TARGET}
    URL ${LUAJIT_SOURCE_DIR}/LuaJIT-${LUAJIT_VERSION}.tar.gz
    BUILD_IN_SOURCE 1
    SOURCE_DIR ${LUAJIT_BUILD_ROOT}/build
    CONFIGURE_COMMAND ""
    BUILD_COMMAND sh ${LUAJIT_BUILD_WRAPPER}
    INSTALL_COMMAND sh ${LUAJIT_INSTALL_WRAPPER}
    UPDATE_COMMAND ""
)

set(LUAJIT_VERSION ${LUAJIT_VERSION} PARENT_SCOPE)
set(LUAJIT_LIBRARY ${LUAJIT_LIBRARY} PARENT_SCOPE)
set(LUAJIT_INCLUDE_DIR ${LUAJIT_INCLUDE_DIR} PARENT_SCOPE)
set(LUAJIT_FOUND TRUE PARENT_SCOPE)

add_custom_target(bundled_luajit)
add_dependencies(bundled_luajit ${LUAJIT_TARGET})

=== src/interfaces/CMakeLists.txt ===
set(EC_TEXT_SRC
            text/ec_text.c
            text/ec_text_conn.c
            text/ec_text_display.c
            text/ec_text_plugin.c
            text/ec_text_profile.c
)
include_directories(text)

set(EC_DAEMON_SRC daemon/ec_daemon.c)

if(ENABLE_CURSES)
    set(EC_CURSES_SRC 
                curses/ec_curses.c
                curses/ec_curses_filters.c
                curses/ec_curses_help.c
                curses/ec_curses_hosts.c
                curses/ec_curses_live.c
                curses/ec_curses_logging.c
                curses/ec_curses_mitm.c
                curses/ec_curses_offline.c
                curses/ec_curses_plugins.c
                curses/ec_curses_start.c
                curses/ec_curses_targets.c
                curses/ec_curses_view.c
                curses/ec_curses_view_connections.c
                curses/ec_curses_view_profiles.c
    )
    include_directories(curses)
    set(EC_WDG_SRC
                curses/widgets/wdg.c
                curses/widgets/wdg_compound.c
                curses/widgets/wdg_debug.c
                curses/widgets/wdg_dialog.c
                curses/widgets/wdg_dynlist.c
                curses/widgets/wdg_error.c
                curses/widgets/wdg_file.c
                curses/widgets/wdg_input.c
                curses/widgets/wdg_list.c
                curses/widgets/wdg_menu.c
                curses/widgets/wdg_panel.c
                curses/widgets/wdg_percentage.c
                curses/widgets/wdg_scroll.c
                curses/widgets/wdg_window.c
    )
    include_directories(curses/widgets)
    add_library(ec_wdg STATIC ${EC_WDG_SRC})
    target_link_libraries(ec_wdg ${EC_LIBS})
endif(ENABLE_CURSES)

if(ENABLE_GTK)
    set(EC_GTK_SRC
                gtk/ec_gtk.c
                gtk/ec_gtk_conf.c
                gtk/ec_gtk_filters.c
                gtk/ec_gtk_help.c
                gtk/ec_gtk_hosts.c
                gtk/ec_gtk_live.c
                gtk/ec_gtk_logging.c
                gtk/ec_gtk_menus.c
                gtk/ec_gtk_mitm.c
                gtk/ec_gtk_offline.c
                gtk/ec_gtk_plugins.c
                gtk/ec_gtk_start.c
                gtk/ec_gtk_targets.c
                gtk/ec_gtk_view.c
                gtk/ec_gtk_view_connections.c
                gtk/ec_gtk_view_profiles.c
    )
    include_directories(gtk)
endif(ENABLE_GTK)


add_library(ec_interfaces STATIC ${EC_TEXT_SRC} ${EC_DAEMON_SRC} ${EC_WDG_SRC} ${EC_CURSES_SRC} ${EC_GTK_SRC})
SET_TARGET_PROPERTIES(ec_interfaces PROPERTIES COMPILE_FLAGS -fPIC)
target_link_libraries(ec_interfaces ${EC_LIBS})

=== debian/changelog ===
ettercap (1:0.8.0-11) unstable; urgency=medium

  * Removing ethtool as b-d for non linux kernels.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Tue, 11 Mar 2014 09:52:02 +0100

ettercap (1:0.8.0-10) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Fixed other failures on kfreebsd and HURD, due to
    missing function on not linux platforms

  [ Barak A. Pearlmutter ]
  * Prep for release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 10 Mar 2014 08:25:34 +0000

ettercap (1:0.8.0-9) unstable; urgency=medium

  * Order matters, for kfreebsd stuff

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sun, 02 Mar 2014 08:10:37 +0100

ettercap (1:0.8.0-8) unstable; urgency=medium

  * Another mod for hurd and kfreebsd

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sat, 01 Mar 2014 13:46:57 +0100

ettercap (1:0.8.0-7) unstable; urgency=medium

  * Hopefully we can get rid of the BPF problem this time.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 28 Feb 2014 10:36:27 +0100

ettercap (1:0.8.0-6) unstable; urgency=medium

  * Fixing kfreebsd-* build failure.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 26 Feb 2014 12:48:14 +0100

ettercap (1:0.8.0-5) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Fixed ettercap-pkexec path failure with previous upload
  * sed s/libtldl-dev/libltdl-dev/g -i debian/control
    to prevent build failures (Closes: #739975)

  [ Barak A. Pearlmutter ]
  * Add Gianfranco Costamagna as co-maintainer

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Feb 2014 19:45:26 +0000

ettercap (1:0.8.0-4) unstable; urgency=medium

  * Move ettercap-pkexec w/ man page from ettercap-common to ettercap-graphical
  * sed s/B0/BZERO/g -i src/ec_encryption_ccmp.c to avoid powerpc build failure

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Feb 2014 14:20:42 +0000

ettercap (1:0.8.0-3) unstable; urgency=medium

  * Install /usr/bin/ettercap not /usr/sbin/ for non-root log analysis
  * Disable LUA support

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 25 Feb 2014 12:08:14 +0000

ettercap (1:0.8.0-2) unstable; urgency=medium

  * Fiddle faddle with the packaging scripts
  * Enable lua support with appropriate build dependencies
  * Name the shared library libettercap.so.0
  * Update the lintian overrides

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 24 Feb 2014 22:43:15 +0000

ettercap (1:0.8.0-1) unstable; urgency=low

  [ Gianfranco Costamagna ]
  * New upstream version
  * Added policykit-1 to ettercap-graphical
  * Added luajit to build-dep
  * Updated debian/rules clean target
  * Removed patches, addressed upstream
  * Added ethtool dependency, needed for disabling
    segmentation offload
  * Tweaked debian/watch file
  * Install libettercap.so in ettercap-common.
  * Added libettercap.so to clean target
  * Bumped standard version to 3.9.5, no changes required.

  [ Raphaël Hertzog ]
  * Drop Debian specific patches:
    - 0001-desktop.patch: upstream uses pkexec by default now, no need to use
      su-to-root, thus drop dep on menu and add dep on policykit-1
    - 0002-centre-scalable-icon.patch: merged upstream
  * Fix CMakeLists.txt to not barf on Debian's
    CMAKE_BUILD_TYPE=RelWithDebInfo.
  * Tweak install files to let upstream install the desktop file, the
    policy kit rules, and the pkexec wrapper.
  * Add some lintian overrides to deal with the internal but public
    libettercap.so.

  [ Barak A. Pearlmutter ]
  * Migrated debian/rules clean target to debian/clean
  * Add "chrpath --delete xxx" to debian/rules as necessary.
  * Apparently Debian passes CMAKE_BUILD_TYPE=RelWithDebInfo; make it so!

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 24 Feb 2014 21:07:04 +0000

=== debian/control ===
Source: ettercap
Section: net
Priority: optional
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Uploaders: Murat Demirten <murat@debian.org>,
 Gianfranco Costamagna <costamagnagianfranco@yahoo.it>
Build-Depends: debhelper (>= 9),
 cmake,
 chrpath,
 bison | bison++ | byacc | byacc-j | yacc | btyacc,
 flex | lex,
 libgtk2.0-dev,
 libltdl-dev | libltdl3-dev,
 libncurses-dev | libncurses5-dev,
 libnet1-dev,
 libpcap-dev | libpcap0.8-dev,
 libpcre3-dev,
 libssl-dev,
 ghostscript,
 libcurl4-openssl-dev | libcurl-ssl-dev | libcurl-dev,
 libbsd-dev
Standards-Version: 3.9.5
Homepage: http://ettercap.sourceforge.net
Vcs-Git: git://github.com/barak/ettercap.git
Vcs-Browser: http://github.com/barak/ettercap

Package: ettercap-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 ethtool [linux-any]
Recommends: ettercap-graphical | ettercap-text-only
Replaces: ettercap-plugins
Conflicts: ettercap-plugins, ettercap (<= 1:0.7.3)
Description: Multipurpose sniffer/interceptor/logger for switched LAN
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the Common support files, configuration files,
 plugins, and documentation.  You must also install either
 ettercap-graphical or ettercap-text-only for the actual GUI-enabled
 or text-only ettercap executable, respectively.

Package: ettercap-text-only
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ettercap-common (= ${binary:Version})
Replaces: ettercap-gtk, ettercap-graphical, ettercap
Conflicts: ettercap-gtk, ettercap-graphical, ettercap (<= 1:0.7.3)
Provides: ettercap
Description: Ettercap console-mode executable
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap text-mode-only executable.

Package: ettercap-graphical
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ettercap-common (= ${binary:Version}),
 policykit-1
Replaces: ettercap-gtk, ettercap-text-only, ettercap, ettercap-common
Conflicts: ettercap-gtk, ettercap-text-only, ettercap (<= 1:0.7.3)
Provides: ettercap
Recommends: gksu
Description: Ettercap GUI-enabled executable
 Ettercap supports active and passive dissection of many protocols
 (even encrypted ones) and includes many feature for network and host
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap GUI-enabled executable.

Package: ettercap-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 ettercap-common (= ${binary:Version}),
 ettercap-graphical (= ${binary:Version}) | ettercap-text-only (= ${binary:Version})
Description: Debug symbols for Ettercap.
 Ettercap runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

LIBNET_VER := $(shell dpkg --status libnet1-dev | awk '/^Version:/ {print $$2}')

ENABLE_IPV6 := $(shell \
 if dpkg --compare-versions $(LIBNET_VER) ge 1.1.6; \
 then echo ON; \
 else echo OFF; \
 fi)

#For some reasons ettercap FTBFS with -PIC enabled
#/usr/bin/ld.bfd.real: CMakeFiles/lib_ettercap.dir/dissectors/ec_ssh.c.o: relocation R_X86_64_PC32 against symbol `ssh_conn_key' can not be used when making a shared object; recompile with -fPIC
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	@echo LIBNET_VER = $(LIBNET_VER)
	@echo ENABLE_IPV6 = $(ENABLE_IPV6)
	@echo main configuration deferred until build, as it must be done twice

ETTERCAP_OPTIONS= \
 -DENABLE_IPV6=$(ENABLE_IPV6) \
 -DBUNDLED_LIBS=OFF \
 -DENABLE_LUA=OFF \
 -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_auto_build:
	@echo Build the text-only executable:
	dh_auto_configure -- $(ETTERCAP_OPTIONS) -DENABLE_GTK=OFF
	dh_auto_build
	mv obj*/src/ettercap ettercap-text-only
	@echo Build the graphics-enabled executable:
	dh_auto_configure -- $(ETTERCAP_OPTIONS) -DENABLE_GTK=ON
	dh_auto_build

override_dh_install:
	dh_install --list-missing
	mkdir --parents debian/ettercap-text-only/usr/bin/
	cp --preserve=mode ettercap-text-only debian/ettercap-text-only/usr/bin/ettercap
	@echo The ettercap-pkexec man page belongs in ettercap-graphical
	-rm --verbose debian/ettercap-common/usr/share/man/man*/ettercap-pkexec*
	@echo Upstream sets RPATH, which is against Debian policy:
	chrpath --list debian/ettercap-text-only/usr/bin/ettercap
	chrpath --delete debian/ettercap-text-only/usr/bin/ettercap
	chrpath --list debian/ettercap-graphical/usr/bin/ettercap
	chrpath --delete debian/ettercap-graphical/usr/bin/ettercap

override_dh_installdocs:
	dh_installdocs -pettercap-common
	dh_installdocs -Nettercap-common --link-doc=ettercap-common

override_dh_strip:
	dh_strip --dbg-package=ettercap-dbg

=== debian/watch ===
version=3

http://ettercap.github.com/ettercap/downloads.html \
(?:.*[/=]|)v(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)).*
